﻿namespace SelectionWinForms
{
    using System;
    using System.Windows;
    using System.Windows.Forms;
    using Ptv.XServer.Controls.Map.Layers.Shapes;
    using Ptv.XServer.Controls.Map.Symbols;

    public partial class Form1 : Form
    {
        private const string token = "INSERT TOKEN HERE";

        SelectInteractor selectInteractor;

        public Form1()
        {
            InitializeComponent();

            // initialize base map (for xServer internet)
            formsMap1.XMapUrl = "https://xmap-eu-n-test.cloud.ptvgroup.com/xmap/ws/XMap";
            formsMap1.XMapCredentials = "xtok:" + token;

            // add layer
            var myLayer = new ShapeLayer("ManySymbols") { LazyUpdate = true };
            this.formsMap1.Layers.Add(myLayer);

            // copied from DemoCenter Selection use case
            var center = new Point(8.4, 49); // KA
            const int radius = 1; // radius in degrees of latitude

            var rand = new Random();
            Func<Point, double, Point> randomCoordinate = (c, r) =>
            {
                var angle = rand.NextDouble() * 2 * Math.PI;
                var distance = r * Math.Sqrt(rand.NextDouble());

                return new Point { X = c.X + distance * Math.Cos(angle), Y = c.Y + distance * Math.Sin(angle) };
            };

            // we don't use bitmap cache here, we use individual Pins
            var pin = new Pin();
            pin.Width = pin.Height = 10;

            pin.Measure(new Size(pin.Width, pin.Height));
            pin.Arrange(new Rect(0, 0, pin.Width, pin.Height));

            for (var i = 0; i < 500; i++)
            {
                Pin symbol;
                symbol = new Pin();
                symbol.Width = pin.Height = 10;
                ShapeCanvas.SetLocation(symbol, randomCoordinate(center, radius));
                symbol.ToolTip = "Hello";
                myLayer.Shapes.Add(symbol);
            }

            // set center and zoom level
            this.formsMap1.SetMapLocation(center, 9);

            // get the map view containing the content
            var mapView = Ptv.XServer.Controls.Map.Tools.MapElementExtensions.FindChild<Ptv.XServer.Controls.Map.MapView>(formsMap1.WrappedMap);

            // set selection iterator
            selectInteractor = new SelectInteractor(mapView, myLayer.Shapes, formsMap1.WrappedMap, formsMap1);
        }
    }
}
